/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class BFF extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         BFF.class,
         "BFF",
         false,
         new ArgumentDecls()
             .add("cc", COND_CODE)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final Location cc = (Location) getArgument("cc", args);
      final Location offset = (Location) getArgument("offset", args);

      return new BFF(cc, offset);
    }
  }

  public static final IInfo INFO = new Info();

  private final Location cc;
  private final Location offset;

  public BFF(Location cc, Location offset) {
    assert COND_CODE.equals(cc.getType());
    assert SHORT.equals(offset.getType());

    this.cc = cc;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("BFF %d, <label>%d", cc.load().bigIntegerValue(), offset.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("01000101000%s00%s", cc.load().toString(), offset.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    if (FCCR.access().bitField(cc.load(), cc.load()).load().equals(Data.valueOf(Type.INT(1), 0x0))) {
      BRANCH.access().store(Data.valueOf(BIT, 0x1));
      JMPADDR.access().store(NIA.access().load().add(Data.signExtend(WORD, offset.load()).shiftLeft(Data.valueOf(WORD, 0x3))));
    }
    } finally {
    actionEnd();
    }
  }
}
