/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class vliw extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         vliw.class,
         "vliw",
         true,
         new ArgumentDecls()
             .add("c1", channel1.INFO)
             .add("c2", channel2.INFO),
         true,
         true,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IOperation c1 = (IOperation) getArgument("c1", args);
      final IOperation c2 = (IOperation) getArgument("c2", args);

      return new vliw(c1, c2);
    }
  }

  public static final IInfo INFO = new Info();

  private final IOperation c1;
  private final IOperation c2;

  public vliw(IOperation c1, IOperation c2) {
    assert channel1.INFO.isSupported(c1);
    assert channel2.INFO.isSupported(c2);

    this.c1 = c1;
    this.c2 = c2;
  }

  @Override
  public String syntax() {
    return String.format("%s; %s;", c1.syntax(), c2.syntax());
  }

  @Override
  public String image() {
    return String.format("%s%s", c1.image(), c2.image());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    NIA.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x8)));
    GPR.access(0).store(Data.valueOf(WORD, 0x0));
    c1.action();
    GPR.access(0).store(Data.valueOf(WORD, 0x0));
    c2.action();
    if (BRANCH.access().load().equals(Data.valueOf(BIT, 0x0))) {
      CIA.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x8)));
    } else {
      CIA.access().store(JMPADDR.access().load());
      __CTRL_TRANSFER.set(1);
    }
    } finally {
    actionEnd();
    }
  }
}
